wayland::server::shell_t(3)

NAME
wayland::server::shell_t - create desktop-style surfaces

SYNOPSIS

#include <wayland-server-protocol.hpp>

Inherits wayland::server::resource_t.

  Public Member Functions

std::function< void(shell_surface_t, surface_t)> & on_get_shell_surface ()
create a shell surface from a surface
void post_role (std::string const &msg)
Post error: given wl_surface has another role.
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
void post_no_memory () const
uint32_t get_id () const
client_t get_client () const
unsigned int get_version () const
std::string get_class ()

Detailed Description

create desktop-style surfaces

This interface is implemented by servers that provide desktop-style user interfaces.

It allows clients to associate a wl_shell_surface with a basic surface.

Note! This protocol is deprecated and not intended for production use. For desktop-style user interfaces, use xdg_shell. Compositors and clients should not implement this interface.

Definition at line 1669 of file wayland-server-protocol.hpp.

Member Function Documentation

  std::string wayland::server::resource_t::get_class () [inherited]
Retrieve the interface name (class) of a resource object.

Returns
    Interface name of the resource object.

  client_t wayland::server::resource_t::get_client () const [inherited]
Get the associated client

Returns
    the client that owns the resource.

  uint32_t wayland::server::resource_t::get_id () const [inherited]
Get the internal ID of the resource

Returns
    the internal ID of the resource

  unsigned int wayland::server::resource_t::get_version () const [inherited]
Get interface version

Returns
    Interface version this resource has been constructed with.

  std::function< void(shell_surface_t, surface_t)> & shell_t::on_get_shell_surface ()

create a shell surface from a surface

Parameters
    id shell surface to create
    surface surface to be given the shell surface role

Create a shell surface for an existing surface. This gives the wl_surface the role of a shell surface. If the wl_surface already has another role, it raises a protocol error.

Only one shell surface can be associated with a given surface.

Definition at line 2220 of file wayland-server-protocol.cpp.

  void wayland::server::resource_t::post_no_memory () const [inherited]
Post 'not enough memory' error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

  void shell_t::post_role (std::string const & msg)

Post error: given wl_surface has another role.

Definition at line 2226 of file wayland-server-protocol.cpp.

  bool wayland::server::resource_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

Author

Generated automatically by Doxygen for Wayland++ from the source code.